import { TerraDrawMouseEvent, TerraDrawAdapterStyling, TerraDrawKeyboardEvent, HexColorStyling, NumericStyling, Cursor } from "../../common";
import { BaseModeOptions, CustomStyling, TerraDrawBaseDrawMode } from "../base.mode";
import { GeoJSONStoreFeatures } from "../../store/store";
type TerraDrawFreehandModeKeyEvents = {
    cancel: KeyboardEvent["key"] | null;
    finish: KeyboardEvent["key"] | null;
};
type FreehandPolygonStyling = {
    fillColor: HexColorStyling;
    outlineColor: HexColorStyling;
    outlineWidth: NumericStyling;
    fillOpacity: NumericStyling;
    closingPointColor: HexColorStyling;
    closingPointWidth: NumericStyling;
    closingPointOutlineColor: HexColorStyling;
    closingPointOutlineWidth: NumericStyling;
};
interface Cursors {
    start?: Cursor;
    close?: Cursor;
}
interface TerraDrawFreehandModeOptions<T extends CustomStyling> extends BaseModeOptions<T> {
    minDistance?: number;
    preventPointsNearClose?: boolean;
    keyEvents?: TerraDrawFreehandModeKeyEvents | null;
    cursors?: Cursors;
}
export declare class TerraDrawFreehandMode extends TerraDrawBaseDrawMode<FreehandPolygonStyling> {
    mode: string;
    private startingClick;
    private currentId;
    private closingPointId;
    private minDistance;
    private keyEvents;
    private cursors;
    private preventPointsNearClose;
    constructor(options?: TerraDrawFreehandModeOptions<FreehandPolygonStyling>);
    private close;
    /** @internal */
    start(): void;
    /** @internal */
    stop(): void;
    /** @internal */
    onMouseMove(event: TerraDrawMouseEvent): void;
    /** @internal */
    onClick(event: TerraDrawMouseEvent): void;
    /** @internal */
    onKeyDown(): void;
    /** @internal */
    onKeyUp(event: TerraDrawKeyboardEvent): void;
    /** @internal */
    onDragStart(): void;
    /** @internal */
    onDrag(): void;
    /** @internal */
    onDragEnd(): void;
    /** @internal */
    cleanUp(): void;
    /** @internal */
    styleFeature(feature: GeoJSONStoreFeatures): TerraDrawAdapterStyling;
    validateFeature(feature: unknown): feature is GeoJSONStoreFeatures;
}
export {};
